package com.FranckBarbier._Java._Railcar_control_system;

import java.beans.*;

import com.pauware.pauware_engine._Core.*;
import com.pauware.pauware_engine._Exception.*;
import com.pauware.pauware_engine._Java_EE.*;

public final class Cruiser extends Object implements java.io.Serializable {

    /**
     * JavaBeans
     */
    protected static final String Disengaged = "Disengaged";
    protected static final String Engaged20 = "Engaged20";
    protected static final String Engaged80 = "Engaged80";
    protected static final String Cruiser = "Cruiser";
    protected PropertyChangeSupport _propertySupport;
    /**
     * UML statechart
     */
    protected AbstractStatechart _Disengaged;
    protected AbstractStatechart _Engaged20;
    protected AbstractStatechart _Engaged80;
    protected AbstractStatechart_monitor _Cruiser_state_machine;

    private void init_structure() throws Statechart_exception {
    }

    private void init_behavior() throws Statechart_exception {
        _Disengaged = new Statechart(Disengaged);
        _Disengaged.inputState();
        _Engaged20 = new Statechart(Engaged20);
        _Engaged80 = new Statechart(Engaged80);
        _Cruiser_state_machine = new Statechart_monitor(_Disengaged.xor(_Engaged20).xor(_Engaged80), Cruiser);
    }

    void start(String railcar) throws Statechart_exception {
        _Cruiser_state_machine.name(_Cruiser_state_machine.name() + '>' + railcar);
        _Cruiser_state_machine.fires("set_Disengaged", _Engaged20, _Disengaged);
        _Cruiser_state_machine.fires("set_Engaged20", _Disengaged, _Engaged20);
        _Cruiser_state_machine.fires("set_Engaged20", _Engaged80, _Engaged20);
        _Cruiser_state_machine.fires("set_Engaged80", _Disengaged, _Engaged80);
        _Cruiser_state_machine.fires("set_Engaged80", _Engaged20, _Engaged80);
        _Cruiser_state_machine.start();
    }

    void stop() throws Statechart_exception {
        _Cruiser_state_machine.stop();
    }

    public Cruiser() throws Statechart_exception {
        init_structure();
        init_behavior();
        _propertySupport = new PropertyChangeSupport(this);
    }

    public boolean get_Disengaged() {
        return _Disengaged.active();
    }

    public void set_Disengaged() throws Statechart_exception {
        boolean old_value = get_Disengaged();
        _Cruiser_state_machine.run_to_completion("set_Disengaged");
        boolean new_value = get_Disengaged();
        _propertySupport.firePropertyChange(Disengaged, old_value, new_value);
    }

    public boolean get_Engaged20() {
        return _Engaged20.active();
    }

    public void set_Engaged20() throws Statechart_exception {
        boolean old_value = get_Engaged20();
        _Cruiser_state_machine.run_to_completion("set_Engaged20");
        boolean new_value = get_Engaged20();
        _propertySupport.firePropertyChange(Engaged20, old_value, new_value);
    }

    public boolean get_Engaged80() {
        return _Engaged80.active();
    }

    public void set_Engaged80() throws Statechart_exception {
        boolean old_value = get_Engaged80();
        _Cruiser_state_machine.run_to_completion("set_Engaged80");
        boolean new_value = get_Engaged80();
        _propertySupport.firePropertyChange(Engaged80, old_value, new_value);
    }

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        _propertySupport.addPropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        _propertySupport.removePropertyChangeListener(listener);
    }
}
