package com.FranckBarbier._Java._Railcar_control_system;

@javax.ejb.Local
public interface Railcar extends com.pauware.pauware_engine._Core.Manageable_base {

    String Stopped_on_railway = "Stopped on railway";
    String Wait_for_terminal_order = "Wait for terminal order";
    String Wait_for_alert80 = "Wait for alert80";
    String Arriving = "Arriving";
    String Cruising = "Cruising";
    String Stopped_at_terminal = "Stopped at terminal";

    /**
     * Simulation:
     */
    boolean has_for_destination(String terminal);

    String get_name();

    boolean destination_board_is_empty();

    void start(String railcar) throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void alert100(Terminal terminal, Railcar railcar, Boolean is_clockwise) throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void alert80(Terminal terminal, Railcar railcar, Boolean is_clockwise) throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void go() throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void go_on() throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void new_destination(String another_terminal) throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void stop() throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void terminal_crossing() throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void terminal_stopping() throws com.pauware.pauware_engine._Exception.Statechart_exception;
}
