package com.FranckBarbier._Java._Railcar_control_system;

@javax.ejb.Local
public interface Terminal extends com.pauware.pauware_engine._Core.Timed_component, com.pauware.pauware_engine._Core.Manageable_base {

    long Parking_time = 3000L; // value in spec. is 30000L
    String Busy = "Busy";
    String Idle = "Idle";

    String get_name();

    boolean destination_board_is_empty();

    void start(String terminal) throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void alert100(Terminal terminal, Railcar railcar, Boolean is_clockwise) throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void approaching(Terminal terminal, Railcar railcar, Boolean is_clockwise) throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void new_destination(String another_terminal) throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void terminal_crossing(Terminal terminal, Railcar railcar, Boolean is_clockwise) throws com.pauware.pauware_engine._Exception.Statechart_exception;

    void terminal_stopping(Terminal terminal, Railcar railcar, Boolean is_clockwise) throws com.pauware.pauware_engine._Exception.Statechart_exception;
}
