package com.FranckBarbier._Java._Railcar_control_system;

@javax.ejb.Remote
public interface Control_center_remote {

    int number_of_terminals();

    int number_of_railcars();

    String get_first_terminal();

    String get_clockwise_next(String terminal);

    String get_counterclockwise_next(String terminal);

    boolean is_terminal_in_state(String terminal, String state);

    boolean terminal_destination_board_is_empty(String terminal);

    String[] get_railcars(String[] railcars);

    boolean get_is_clockwise(String railcar);

    String get_origin_terminal(String railcar);

    String get_end_terminal(String railcar);

    boolean is_railcar_in_state(String railcar, String state);

    boolean railcar_destination_board_is_empty(String railcar);
}
