package com.FranckBarbier._Java._Railcar_control_system;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@Entity
@Table(name = "RAILCAR")
@NamedQueries({
    @NamedQuery(name = "Railcar.findAll", query = "SELECT r FROM Railcar_POJO r"),
    @NamedQuery(name = "Railcar.findByRailcar", query = "SELECT r FROM Railcar_POJO r WHERE r._railcar = :railcar")})
public class Railcar_POJO implements java.io.Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 30)
    @Column(name = "RAILCAR")
    private String _railcar;
    @Column(name = "IS_CLOCKWISE")
    private Integer isClockwise;
    @JoinColumn(name = "ORIGIN_TERMINAL", referencedColumnName = "TERMINAL")
    @ManyToOne(fetch = FetchType.EAGER)
    private Terminal_POJO originTerminal;
    @JoinColumn(name = "END_TERMINAL", referencedColumnName = "TERMINAL")
    @ManyToOne(fetch = FetchType.EAGER)
    private Terminal_POJO endTerminal;

    public Railcar_POJO() {
    }

    public Railcar_POJO(String railcar) {
        _railcar = railcar;
    }

    public String get_railcar() {
        return _railcar;
    }

    public void set_railcar(String railcar) {
        _railcar = railcar;
    }

    public Integer getIsClockwise() {
        return isClockwise;
    }

    public void setIsClockwise(Integer isClockwise) {
        this.isClockwise = isClockwise;
    }

    public Terminal_POJO getOriginTerminal() {
        return originTerminal;
    }

    public void setOriginTerminal(Terminal_POJO originTerminal) {
        this.originTerminal = originTerminal;
    }

    public Terminal_POJO getEndTerminal() {
        return endTerminal;
    }

    public void setEndTerminal(Terminal_POJO endTerminal) {
        this.endTerminal = endTerminal;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (_railcar != null ? _railcar.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Railcar_POJO)) {
            return false;
        }
        Railcar_POJO other = (Railcar_POJO) object;
        if ((_railcar == null && other._railcar != null) || (_railcar != null && !_railcar.equals(other._railcar))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return get_railcar();
    }
}
