package com.FranckBarbier._Java._Railcar_control_system;

import java.util.Collection;
import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@Entity
@Table(name = "TERMINAL")
@NamedQueries({
    @NamedQuery(name = "Terminal.findAll", query = "SELECT t FROM Terminal_POJO t"),
    @NamedQuery(name = "Terminal.findByTerminal", query = "SELECT t FROM Terminal_POJO t WHERE t._terminal = :terminal")})
public class Terminal_POJO implements java.io.Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 30)
    @Column(name = "TERMINAL")
    private String _terminal;
    @Size(max = 30)
    @Column(name = "CLOCKWISE_NEXT")
    private String _clockwise_next;
    @Size(max = 30)
    @Column(name = "COUNTERCLOCKWISE_NEXT")
    private String _counterclockwise_next;
    @OneToMany(mappedBy = "originTerminal", fetch = FetchType.EAGER)
    private Collection<Railcar_POJO> _railcars_as_origin_terminal;
    @OneToMany(mappedBy = "endTerminal", fetch = FetchType.EAGER)
    private Collection<Railcar_POJO> _railcars_as_end_terminal;

    public Terminal_POJO() {
    }

    public Terminal_POJO(String terminal) {
        _terminal = terminal;
    }

    public String get_terminal() {
        return _terminal;
    }

    public void set_terminal(String terminal) {
        _terminal = terminal;
    }

    public String get_clockwise_next() {
        return _clockwise_next;
    }

    public void set_clockwise_next(String clockwise_next) {
        _clockwise_next = clockwise_next;
    }

    public String get_counterclockwise_next() {
        return _counterclockwise_next;
    }

    public void set_counterclockwise_next(String counterclockwise_next) {
        _counterclockwise_next = counterclockwise_next;
    }

    public Collection<Railcar_POJO> get_railcars_as_origin_terminal() {
        return _railcars_as_origin_terminal;
    }

    public void set_railcars_as_origin_terminal(Collection<Railcar_POJO> railcars_as_origin_terminal) {
        _railcars_as_origin_terminal = railcars_as_origin_terminal;
    }

    public Collection<Railcar_POJO> get_railcars_as_end_terminal() {
        return _railcars_as_end_terminal;
    }

    public void set_railcars_as_end_terminal(Collection<Railcar_POJO> railcars_as_end_terminal) {
        _railcars_as_end_terminal = railcars_as_end_terminal;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (_terminal != null ? _terminal.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Terminal_POJO)) {
            return false;
        }
        Terminal_POJO other = (Terminal_POJO) object;
        if ((_terminal == null && other._terminal != null) || (_terminal != null && !_terminal.equals(other._terminal))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return get_terminal();
    }
}
